
local ldb = LibStub("LibDataBroker-1.1")

--[[
local localizedClasses = {}
FillLocalizedClassList(localizedClasses)
local classLabels = {}
    populateClassLabels("HUNTER")
    populateClassLabels("WARRIOR")
    populateClassLabels("PALADIN")
    populateClassLabels("MAGE")
    populateClassLabels("PRIEST")
    populateClassLabels("WARLOCK")
    populateClassLabels("SHAMAN")
    populateClassLabels("DEATHKNIGHT")
    populateClassLabels("DRUID")
    populateClassLabels("MONK")
    populateClassLabels("ROGUE")
	
local populateClassLabels(class)
	classLabels[class] = {localizedClasses[class], RAID_CLASS_COLORS[class]}
	print(classLabels[class][1], classLabels[class][2], classLabels[class][3], classLabels[class][4])
end
--]]
	
-- displayName, active, {buff = {class [, note]}, ...}
local buffsList = {
	{"Stats", false, {
		[20217]  = {"PALADIN"}, -- Blessing of Kings
		[117666] = {"MONK"}, -- Legacy of the Emperor (old?)
		[115921] = {"MONK"}, -- Legacy of the Emperor
		[116781] = {"MONK"}, -- Legacy of the White Tiger
		[1126]   = {"DRUID"}, -- Mark of the Wild
		[159988] = {"HUNTER"}, -- Bark of the Wild (Dog)
		[160017] = {"HUNTER"}, -- Blessing of Kongs (Gorilla)
		[90363]  = {"HUNTER", "Exotic Pet"}, -- Embrace of the Shale Spider 
		[90363]  = {"HUNTER", "Exotic Pet"}, -- Strength of the Earth (Worm) 
        [69378] = {nil}, -- Blessing of Forgotten Kings (Leatherworking Drums)
		[160077] = {"Krasang Wilds Druid"}, -- Dominion Point/Lion's Landing NPCs
	}},
	{"Attack Power", false, {
		[19506]  = {"HUNTER"}, -- Trueshot Aura
		[6673]   = {"WARRIOR"}, -- Battle Shout
		[57330]  = {"DEATHKNIGHT"}, -- Horn of Winter
		[133540] = {"Krasang Wilds Warrior"}, -- Dominion Point/Lion's Landing NPCs
	}},
	{"Spell Power", false, {
		[1459]   = {"MAGE"}, -- Arcane Brilliance
		[61316]  = {"MAGE"}, -- Dalaran Brilliance
		[109773] = {"WARLOCK"}, -- Dark Intent
		[128433] = {"HUNTER", "Pet"}, -- Serpent's Cunning
		[90364]  = {"HUNTER", "Exotic Pet"}, -- Qiraji Fortitude
		[126309] = {"HUNTER", "Exotic Pet"}, -- Still Water
		[133533] = {"Krasang Wilds Mage"}, -- Dominion Point/Lion's Landing NPCs
	}},
	{"Haste", false, {
		[55610] = {"DEATHKNIGHT", "Frost & Unholy"}, -- Unholy Aura
		[49868] = {"PRIEST", "Shadow"}, -- Mind Quickening
		[113742] = {"ROGUE"}, -- Swiftblade's Cunning
		[116956] = {"SHAMAN"}, -- Grace of Air
		[128432] = {"HUNTER", "Pet"}, -- Cackling Howl
		[160003] = {"HUNTER", "Pet"}, -- Savage Vigor
		[135678] = {"HUNTER", "Pet"}, -- Energizing Spores
		[160074] = {"HUNTER", "Pet"}, -- Speed of the Swarm
		[133541] = {"Krasang Wilds Rogue"}, -- Dominion Point/Lion's Landing NPCs
	}},
	{"Mastery", false, {
        [155522] = {"DEATHKNIGHT", "Blood"}, -- Power of the Grave
		[24907]  = {"DRUID", "Balance"}, -- Moonkin Aura
		[19740]  = {"PALADIN"}, -- Blessing of Might
		[116956] = {"SHAMAN"}, -- Grace of Air
		[93435]  = {"HUNTER", "Pet"}, -- Roar of Courage
		[160039] = {"HUNTER", "Pet"}, -- Keen Senses
		[128997] = {"HUNTER", "Exotic Pet"}, -- Spirit Beast Blessing
		[160073] = {"HUNTER", "Pet"}, -- Roar of Courage
		[133535] = {"Krasang Wilds Paladin"}, -- Dominion Point/Lion's Landing NPCs
	}},
	{"Critical Strike", false, {
		[1459]   = {"MAGE"}, -- Arcane Brilliance
		[61316]  = {"MAGE"}, -- Dalaran Brilliance
		[17007]  = {"DRUID", "Feral & Guardian"}, -- Leader of the Pack
		[116781] = {"MONK", "Windwalker"}, -- Legacy of the White Tiger
		[90309]  = {"HUNTER", "Exotic Pet"}, -- Terrifying Roar
		[126373] = {"HUNTER", "Exotic Pet"}, -- Fearless Roar
		[160052] = {"HUNTER", "Pet"}, -- Strength of the Pack
		[90363]  = {"HUNTER", "Exotic Pet"}, -- Embrace of the Shale Spider 
		[126309] = {"HUNTER", "Exotic Pet"}, -- Still Water
		[24604]  = {"HUNTER", "Pet"}, -- Furious Howl
		[133533] = {"Krasang Wilds Mage"}, -- Dominion Point/Lion's Landing NPCs
	}},
	{"Stamina", false, {
		[21562]  = {"PRIEST"}, -- Power Word: Fortitude
		[166928] = {"WARLOCK"}, -- Blood Pact
		[469]    = {"WARRIOR"}, -- Commanding Shout
		[24604]  = {"HUNTER", "Pet"}, -- Invigorating Roar
		[160014] = {"HUNTER", "Pet"}, -- Sturdiness
		[160003] = {"HUNTER", "Pet"}, -- Savage Vigor
		[90364]  = {"HUNTER", "Exotic Pet"}, -- Qiraji Fortitude
        [111922] = {nil}, -- Fortitude (Inscription Scroll)
		[133538] = {"Krasang Wilds Priest"}, -- Dominion Point/Lion's Landing NPCs
	}},
	{"Multistrike", false, {
		[166916] = {"Monk", "Windwalker"}, -- Windflurry
		[49868]  = {"PRIEST", "Shadow"}, -- Mind Quickening
		[113742] = {"ROGUE"}, -- Swiftblade's Cunning
		[109773] = {"WARLOCK"}, -- Dark Intent
		[50519]  = {"HUNTER", "Pet"}, -- Sonic Focus
		[57386]  = {"HUNTER", "Pet"}, -- Wild Strength
		[58604]  = {"HUNTER", "Pet"}, -- Double Bite
		[34889]  = {"HUNTER", "Pet"}, -- Spry Attacks
		[24844]  = {"HUNTER", "Pet"}, -- Breath of the Winds
	}},
	{"Versatility", false, {
		[55610]  = {"DEATHKNIGHT", "Frost & Unholy"}, -- Unholy Aura
		[1126]   = {"DRUID"}, -- Mark of the Wild
        [167187] = {"PALADIN"}, -- Sanctity Aura
		[49868]  = {"WARRIOR", "Arms & Fury"}, -- Inspiring Presence
		[159735] = {"HUNTER", "Pet"}, -- Tenacity
		[35290]  = {"HUNTER", "Pet"}, -- Indomitable
		[57386]  = {"HUNTER", "Pet"}, -- Wild Strength
		[160045] = {"HUNTER", "Pet"}, -- Defensive Quills
		[50518]  = {"HUNTER", "Pet"}, -- Chitinous Armor
		[173035] = {"HUNTER", "Pet"}, -- Grace
		[90363]  = {"HUNTER", "Exotic Pet"}, -- Strength of the Earth (Worm) 
	}},
}

local BrokerRaidBuffs = ldb:NewDataObject("Broker_RaidBuffs", {
	type = "data source",
	text = "Please wait",
	value = 1,
	icon = "interface\\addons\\Broker_RaidBuffs\\BuffConsolidation",
	label = "RaidBuffs",
	OnTooltipShow = function(tooltip)
		tooltip:AddLine("Raidbuffs")
		for _,v in pairs(buffsList) do
			local r, g, b
			if v[2] then
				r, g, b = 0, 1, 0
			else
				r, g, b = 1, 0, 0
			end
			tooltip:AddLine(v[1], r, g, b)
		end
	end
})

local function updateBuffs(self, event, unitID)
	if (unitID == "player" or event == "PLAYER_ENTERING_WORLD") then
		-- unflag the active buffs
		for i=1, #buffsList do
			buffsList[i][2] = false
		end
		
		-- populate our buffs lookup table
		local activeBuffs, i = {}, 1
		local currentBuff = select(11, UnitBuff("player", i))
		while currentBuff do
			activeBuffs[currentBuff] = true
			i = i + 1
			currentBuff = select(11, UnitBuff("player", i))
		end
		
		local activeRaidBuffs = 0
		-- start the lookup
		for i = 1, #buffsList do
			local raidBuff = buffsList[i][3]
			for key, _ in pairs(raidBuff) do
				if activeBuffs[key] then
					buffsList[i][2] = true
					activeRaidBuffs = activeRaidBuffs + 1
					break
				end
			end
		end
		
		BrokerRaidBuffs.text = activeRaidBuffs .. " / " .. #buffsList
	end
end

local EventFrame = CreateFrame("Frame")
EventFrame:RegisterEvent("UNIT_AURA")
EventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
EventFrame:SetScript("OnEvent", updateBuffs)